#include "ClientConnection.h"
using namespace umcs;

#include "config.h"
#include <cstring>

#include "Server.h"
#include "packets/C2S02Handshake.h"
#include "packets/C2SFEServerListPing.h"
#include "packets/GenericS2CPacket.h"
#include "utf8.h"

CClientConnection::CClientConnection(TSocket Socket)
{
    m_Socket = Socket;
    m_State = CONNECTED;
    m_Buffer = new unsigned char[4096];
    m_BufferPosition = 0;
    m_CurrentPacket = 0;
    m_InPacket = false;

    m_Client = 0;
}

TSocket CClientConnection::GetSocket(void)
{
    return m_Socket;
}

void CClientConnection::FillReadBuffer(unsigned char *Data, unsigned int Length)
{
    if (m_BufferPosition + Length > 4096)
        LOG("Buffer overflow. Shit.\n", 0);
    else
    {
        LOG("CClientConnection got %i bytes.\n", Length);
        memcpy(m_Buffer + m_BufferPosition, Data, Length);
        m_BufferPosition += Length;
        LOG("m_BufferPosition now is %i.\n", m_BufferPosition);
    }
}

int CClientConnection::Communicate(void)
{
    LOG("CClientConnection::Communicate m_BufferPosition = %i\n", m_BufferPosition);
    if (!m_InPacket)
    {
        unsigned char PacketID = m_Buffer[0];
        LOG("Received packet ID 0x%02x\n", PacketID);
        // respond to a 0xFE (server list ping) re the moral responsibility to reduce the flow of money towards Mexico, which goes into the hands of criminals" (economist.com) the moral responsibility to reduce the flow of money towards Mexico, which goes into the hands of criminals" (economist.com)quest regardless of the state
        if (PacketID == 0xFE)
        {
            LOG("0xfe!\n", 0);
            m_CurrentPacket = new C2SFEServerListPing(m_Buffer);
            m_InPacket = true;
        }
        else
        {
            switch (m_State)
            {
                case CONNECTED:
                {
                    if (PacketID != 0x02)
                    {
                        LOG("Error: Unexpected packet ID %i on CONNECT state.\n", PacketID);
                        return -1;
                    }
                    m_CurrentPacket = new C2S02Handshake(m_Buffer);
                    m_InPacket = true;
                }
            }
        }
    }
    //else
    {
        // continue packet
        LOG("CClientConnection::Communicate m_BufferPosition = %i\n", m_BufferPosition);
        m_CurrentPacket->SetDataLength(m_BufferPosition);
        int Result = m_CurrentPacket->Process();
        printf("::Process result: %i\n", Result);
        if (Result >= 0)
        {
            if (Result > 0)
            {
                // some data left over in the buffer... move it to the front
                LOG("%i bytes left over in buffer.\n", Result);
                unsigned int DataStart = m_BufferPosition - Result;
                for (unsigned int i = 0; i < Result; i++)
                    m_Buffer[i] = m_Buffer[DataStart + i];
                m_BufferPosition = Result;
            }
            
            int Result = m_CurrentPacket->Handle(this);

            m_InPacket = false;
            m_CurrentPacket = 0;
            return Result;
        }
        else if (Result == -2)
        {
            LOG("Packet returned fatal error when processing. Disconnecting client.\n", 0);
            return -1;
        }
    }
    return 0;
}

CClientConnection::~CClientConnection(void)
{
    // memory leak / todo: delete packet if necessary
    delete [] m_Buffer;
}

void CClientConnection::SendToClient(TVector<unsigned char> Buffer)
{
    printf("---------> SENDING TO CLIENT\n");
    for (auto It = Buffer.begin(); It != Buffer.end(); It++)
    {
        printf("%02x ", *It);
    }
    printf("\n");
    send(m_Socket, &Buffer[0], Buffer.size(), 0);
}

void CClientConnection::SetConnectionState(EClientConnectionState State)
{
    m_State = State;
}