#ifndef __CLIENT_CONNECTION_H__
#define __CLIENT_CONNECTION_H__

#include "packets/GenericC2SPacket.h"
#include "Client.h"
#include "config.h"

namespace umcs {
    enum EClientConnectionState {
        // connection mechanism...
        CONNECTED,
        HANDSHAKE,
        ENCRYPTION_RESPONSE,

        // from now on everything is encrypted
        AWAITING_LOGIN,

        // in game - normal
        IN_GAME
    };
    class CClientConnection {
    friend class CGenericC2SPacket;
    private:
        CGenericC2SPacket *m_CurrentPacket;
        bool m_InPacket;
        CClient *m_Client;

        void SlideBufferWindow(unsigned int RemainingBytes);
    protected:
        TSocket m_Socket;
        EClientConnectionState m_State;
        unsigned char *m_Buffer;
        unsigned int m_BufferPosition;
    public:
        CClientConnection(TSocket Socket);
        EClientConnectionState GetConnectionState(void);
        TSocket GetSocket(void);
        void FillReadBuffer(unsigned char *Data, unsigned int Length);
        int Communicate(void);
        void SetConnectionState(EClientConnectionState State);
        void SendToClient(TVector<unsigned char>Bufer);
        ~CClientConnection(void);
    };
};

#endif