#ifndef __SERVER_H__
#define __SERVER_H__

#include "config.h"
#include "ClientConnection.h"

extern "C"
{
    #include <sys/types.h>
    #include <sys/socket.h> 
    #include <netinet/in.h>
    #include <fcntl.h>
    #include <sys/select.h>
    #include <unistd.h>
}

namespace umcs {
    // basic server class that uses BSD sockets
    class CServer {
    private:
        fd_set m_RSockets;
        TSocket Select(unsigned int TimeoutMicro);
        int MakeSocketNonBlocking(TSocket Socket);
    protected:
        TSocket m_GameSocket;
        TVector <CClientConnection *> m_ClientConnections;
        short m_GamePort;
    public:
        // default constructor that binds to all interfaces
        CServer(short Port);

        // start the server
        int Run(void);
    };
};

#endif