#ifndef __CONFIG_H__
#define __CONFIG_H__

// desktop / BSD socket build - let's use STL structures
#include <vector>
#define TVector std::vector
typedef int TSocket;

#include <stdio.h>
#include <cstring>
#define LOG(format, ...) printf(format, __VA_ARGS__)

#include "utf8.h"

// shorthand stuf for strings
typedef TVector<unsigned short> utf16str;
typedef TVector<unsigned char> utf8str;

#define UTF16TO8(u16, u8) utf8::utf16to8((u16).begin(), (u16).end(), std::back_inserter(u8))
#define UTF8TO16(u8, u16) utf8::utf8to16((u8).begin(), (u8).end(), std::back_inserter(u16))

inline utf8str MakeUTF8(const char *String)
{
    return utf8str((const unsigned char *)String, (const unsigned char*)String + strlen(String));
}

inline void AppendUTF8(utf8str &Target, const char *String)
{
    Target.insert(Target.end(), String, String + strlen(String));
}

#endif