#include "C2S02Handshake.h"
using namespace umcs;

#include "../config.h"
#include "GenericS2CPacket.h"
#include "../ClientConnection.h"

bool C2S02Handshake::ReadField(unsigned int Field)
{
    switch (Field)
    {
        case 0:
            return ReadByte(m_ProtocolVersion);
        case 1:
            return ReadString(m_Username);
        case 2:
            return ReadString(m_ServerHost);
        case 3:
            return ReadInteger(m_Port);
    }
}

int C2S02Handshake::Handle(CClientConnection *Connection)
{
    LOG("Got handshake for protocol version %i\n", GetProtocolVersion());
    if (GetProtocolVersion() != 49)
    {
        LOG("... that's not a version we support.\n", 0);
        return -1;
    }
    utf8str Username = GetUsername();
    Username.push_back(0);
    LOG("  Username: %s\n", &(Username[0]));

    //m_Client = new CClient(Username16);
    Connection->SetConnectionState(HANDSHAKE);

    // let the client know...
    Connection->SendToClient(CGenericS2CPacket::Serialize(S2CKICK, &MakeUTF8("Sorry, that doesn't work yet!")));

    return 0;
}