#ifndef __C2S02_HANDSHAKE_H__
#define __C2S02_HANDSHAKE_H__

#include "GenericC2SPacket.h"
#include "../config.h"

namespace umcs {
    class C2S02Handshake : public CGenericC2SPacket {
    private:
        char m_ProtocolVersion;
        utf8str m_Username;
        utf8str m_ServerHost;
        int m_Port;
    protected:
        unsigned int GetNumFields(void) { return 4; };
        bool ReadField(unsigned int Field);
    public:
        C2S02Handshake(unsigned char *Buffer) : CGenericC2SPacket(Buffer) { }
        virtual int GetPacketID(void) { return 2; }

        char GetProtocolVersion(void) { return m_ProtocolVersion; }
        const utf8str GetUsername(void) { return m_Username; }
        virtual int Handle(CClientConnection *Connection);
    };
};

#endif