#include "C2SFEServerListPing.h"
using namespace umcs;

#include "../ClientConnection.h"

bool C2SFEServerListPing::ReadField(unsigned int Field)
{
    switch (Field)
    {
        case 0:
            return ReadByte(m_Magic);
    }
}

int C2SFEServerListPing::Handle(CClientConnection *Connection)
{
    if (GetMagic() != 1)
    {
        LOG("Weird server list ping magic %i\n", GetMagic());
        return -1;
    }

    // we have to use custom serialization code here,
    // because the response contains an illegal unicode
    // character;

    utf8str Response;
    // protocol
    AppendUTF8(Response, "49");
    Response.push_back(0);
    // MC version
    AppendUTF8(Response, "1.4.4");
    Response.push_back(0);
    // MOTD
    AppendUTF8(Response, "A umcs server.");
    Response.push_back(0);
    // Player Count
    AppendUTF8(Response, "0");
    Response.push_back(0);
    AppendUTF8(Response, "20");
    Response.push_back(0);

    TVector<unsigned char> Buffer;
    Buffer.push_back(0xFF);
    unsigned int Length = Response.size() + 3;
    Buffer.push_back(Length >> 8);
    Buffer.push_back(Length & 0xFF);
    Buffer.push_back(0x00);
    Buffer.push_back(0xA7);
    Buffer.push_back(0x00);
    Buffer.push_back(0x31);
    Buffer.push_back(0x00);
    Buffer.push_back(0x00);

    for (auto It = Response.begin(); It != Response.end(); It++)
    {
        Buffer.push_back(0);
        Buffer.push_back(*It);
    }

    Connection->SendToClient(Buffer);

    return 0;
}