#ifndef __GENERIC_C2S_PACKET_H__
#define __GENERIC_C2S_PACKET_H__

#include <functional>
#include "../config.h"

namespace umcs {
    class CClientConnection;
    class CGenericC2SPacket {
    private:
        unsigned char *m_Buffer;
        unsigned int m_CurrentByte;
        unsigned int m_AvailableDataLength;

        unsigned int m_CurrentField;

        inline unsigned int GetAvailableBytes(void) { return m_AvailableDataLength - m_CurrentByte; }
        char PeekByte(void);
    protected:
        virtual unsigned int GetNumFields(void) = 0;
        virtual bool ReadField(unsigned int Field) = 0;
        virtual void AllFieldsRead(void) {};

        bool ReadByte(char &Byte);
        bool ReadInteger(int &Integer);
        bool ReadString(utf8str &String);
    public:
        CGenericC2SPacket(unsigned char *Buffer);
        void SetDataLength(unsigned int Length);
        int Process(void);
        virtual int GetPacketID(void) { return -1; }
        virtual int Handle(CClientConnection *Connection) { return -1; };
    };
};

#endif