#include "GenericS2CPacket.h"
using namespace umcs;

#include <cstdarg>
#include <cstring>
#include "../config.h"
#include "../utf8.h"

TS2CPacketDefinition g_PacketDefinitions[] = {
        { S2CKICK, "s" },
        {0, 0}
    };

TVector<unsigned char> CGenericS2CPacket::Serialize(ES2CPacket PacketID, ...)
{
    TVector<unsigned char> Buffer;

    Buffer.push_back(PacketID);

    TS2CPacketDefinition *pDefinition = g_PacketDefinitions;
    while (pDefinition->m_Format != 0)
    {
        if (pDefinition->m_PacketID == PacketID)
        {
            const char *Format = pDefinition->m_Format;
            va_list Arguments;
            va_start(Arguments, PacketID);

            const char *pChar = Format;
            while (*pChar != 0)
            {
                switch (*pChar)
                {
                    case 's':
                    {
                        utf8str *String8 = va_arg(Arguments, utf8str *);
                        unsigned int Length = utf8::distance(String8->begin(), String8->end());
                        utf16str String16;
                        UTF8TO16(*String8, String16);

                        Buffer.push_back(Length >> 8);
                        Buffer.push_back(Length & 0xFF);
                        for (unsigned int i = 0; i < Length; i++)
                        {
                            Buffer.push_back(String16[i] >> 8);
                            Buffer.push_back(String16[i] & 0xFF);
                        }

                        break;
                    }
                    default:
                    {
                        LOG("Unknown format char %c when serializing S2C packet.\n", *pChar);
                    }
                }
                pChar++;
            }
            va_end(Arguments);
            return Buffer;
        }

        pDefinition++;
    }
    return TVector<unsigned char>();
}